Subject: Re: Git mirror at gitlab

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 21 Dec 2023 12:48:12 +0100

On Thu, Dec 21, 2023 at 12:30:02PM +0100, Olliver Schinagl wrote:
> Hey list,
> 
> For years, I wanted (tried, but time) to run the mirror for git on gitlab.
> Actually, the original idea was to run a docker container ([0] 10k+ pulls
> :p)
> 
> I initially set this up via docker build containers, where docker hub would
> pull my mirror of the git repo. My mirror, because I added a Dockerfile
> which was enough for docker to do its trick. I was planning (time ..) on
> submitting this upstream to the list, but never did. Because of me not doing
> that, I had to manually (I was even too lazy to script it) rebase the
> branch. Docker then did some changes to their business, where the docker
> builds where not possible anymore.
> 
> So then I figured, I'll do the same on gitlab and push it to the docker hub.
> Thus I setup a mirror on gitlab [1], with the idea to work there on it.
> 
> Again, I never got around to finalize this work, mostly because the docker
> container 'just worked' for pretty much everything. After all, git is very
> stable overal.
> 
> So very interestingly, last month commit 0e3b67e2aa25edb ("ci: add support
> for GitLab CI") landed, which started to trigger pipeline jobs!
> 
> Sadly, this only worked for 3 builds, as that's when the minutes ran out :)
> 
> So one, I would very much like to offer the registered names (cause they are
> pretty nice in name) to here, so people can use and find it.

Not to throw a wrench into this, but are you aware of the official
GitLab mirror at https://gitlab.com/git-vcs/git? I myself wasn't aware
of this mirror for a rather long time.

I also wondered whether we want to have https://gitlab.com/git/git as we
do on GitHub. I don't think anybody registered it, but it is blocked
from being registered as far as I can tell. Maybe we block the namespace
out of caution, I dunno. I can certainly check in with our SREs in case
it is something the Git project would like to own.

> Two, hopefully get Patrick Steinhardt to help out to get unlimited minutes
> and storage on the repo :)

I'm sure we can do something here, but I'd rather aim to do this for the
official mirror which currently is the one I mentioned above. If the
project is interested in running builds on GitLab then I'm happy to
coordinate.

Also Cc Ævar, who is the current owner of the mirror. Would it be
possible to add myself as a second owner to the project? This might help
setting up the CI infrastructure. But please, if anybody disagrees with
me being added as an owner here I encourage you to say so.

> Three, see what the opinion of people here is on this. I'll do the work to
> get the dockerfile (now containerfile, we're inclusive after all) merged,
> and the CI file updated to create, store (and push to docker hub) the
> generated containers.

I don't really have much of an opinion here and will leave it to others
to discuss.

Thanks!

Patrick

PS: As most other folks I'll be OOO during holidays, so I may only
    answer sporadically.

> Thanks,
> Olliver
> 
> [0]: https://hub.docker.com/r/gitscm/git
> [1]: https://gitlab.com/gitscm/git
> 
> P.S. I'm not subscribed, so please keep me in the CC :)